'###################################################
'Testprogramm 9
'fr
'RoboterNetz Standard-Roboter Board RBNFRA 1.2
' nur fr Board Version >>> 1.2 <<<
'
'Aufgabe:
'Hier werden die Energiesparmglichkeiten
'erlutert. Dazu sollte der Quellcode
'und die Kommentarzeilen gelesen werden
'Das Programm schaltet zuerst alles ein und geht dann
'in einen Energiesparmode. Weitere Energie knnte gespart werden
'wenn man den Controller in den Sleep-Modus setzt
'
'Autor: Frank
'Weitere Beispiele und Beschreibung der Hardware
'unter http://www.Roboternetz.de
'Bezugsquelle http://www.robotikhardware.de
'###################################################

$regfile = "m32def.dat"                                     ' oder bei Mega16 $regfile = "m16def.dat"
Const Energieport_adr = &H74                                'I2C Adr PCF 3


Dim I2cdaten As Byte                                        'Datenbyte aus PCF8574


Dim I As Byte

$crystal = 8000000                                          'Quarzfrequenz
Config Scl = Portc.0                                        'Ports fuer IIC-Bus
Config Sda = Portc.1

I2cinit



'******** Diese 4 Befehle sind nur ab RNBFRA Version 1.2 (nicht in V 1.1)
'Jedes jedes Bit des PCF3 (Energieport) hat spezielle Aufgaben
'Die drei oberen Bits (7,6,5) 'xxx00000'sind mit den Status-Leds verbunden und
'werden auf JP12 bereitgestellt als I/O Ports bereitgestellt. Beachten muss man hier,
'das die LEDs nur leuchten wenn das Bit (Port) auf 0 geschaltet wird

'Die Bits 3+4 sind frei und werden auf JP12 als I/O Ports bereitgestellt.

'Das Bit 2 schaltet die 5V Logikspannung, die auf den Steckern der
'Board Ein- und Ausgnge liegt aus. Damit kann Energie eingespart werden, falls
'Sensoren etc. angeschlossen sind.Ausgeschaltet wird die Spannung indem
'das Bit auf 1 gesetzt wird!

'Das Bit 1 ist das Sleep-Bit des 25 poligen RBNBUS-Steckers. Gewhlich sollte
'dieses Bit auf 1 stehen. Wenn sie es auf 0 schalten, dann sollten andere
'Erweiterungen (Zusatzplatinen die ber den RNB-Bus verbunden sind) in einen
'Energiesparmodus gehen. Dies muss jedoch vom jeweiligen Erweiterungsboard
'untersttzt werden

'Das Bit 0 schaltet die Schrittmotor- und Getriebemotorentstufe aus
'Werden keine Motoren bentigt oder soll der Robote reine kleine Pause
'machen, so kann man hierdurch erheblich Energie sparen. Ausgeschaltet wird die Spannung indem
'das Bit auf 1 gesetzt wird!


' Dies ist die bliche Anweisung die in Programmen stehen sollte
' Mit dieser Codesequenz wird quasi alles aktiviert Eingabeports,Ausgabeports,Status-LEDs,
' Motorentstufe,und SLEEPMODUS wird deaktiviert (also kein Energiesparmode)
 I2cstart
 I2cwbyte Energieport_adr                                   'Schreibbefehl an PCF3 schicken
     ' Leds ein ,Motorendstufen ein, Port-Peripherie ein, RBN-Bus Sleep Modus aus (also Peripherie aktiv)
 I2cwbyte &B00000010                                        'Datenbyte an PCF3
 I2cstop
'*********

 Wait 5

 'Hier erfolgt das Gegenteit. Alles was zum Energiesparen abgeschaltet werden kann, wird abgeschaltet
 I2cstart
 I2cwbyte Energieport_adr                                   'Schreibbefehl an PCF3 schicken
     ' Leds aus ,Motorendstufen ein, Port-Peripherie ein, RBN-Bus Sleep Modus aus (also Peripherie aktiv)
 I2cwbyte &B11100101                                        'Datenbyte an PCF3
 I2cstop



End